﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.RiskAssessmentRCM
@{
    ViewData["Title"] = "Index";
}
<script src="~/Script/ApplicationManagement/GenerateRCM.js"></script>
<script src="~/Script/Master/Layout.js"></script>

<style>
    ul.multiselect-container.dropdown-menu.show {
        max-width: 750px !important;
        float: inherit !important;
        margin-top: 70px !important;
        left: 50% !important;
        transform: translate3d(-121px, -21px, 0px) !important;
    }

    .tab_content {
        display: none;
        padding: 15px 0px;
    }

        .tab_content.active {
            display: block;
        }

    .tab_ul {
        display: block;
    }

    .tab_ul_in {
        margin: 0px;
        padding: 0px;
        border-bottom: solid 1px #ccc;
    }

        .tab_ul_in li {
            display: inline-block;
            list-style-type: none;
            margin-right: 8px;
            border-radius: 5px 5px 0px 0px;
            background-color: #eaeaea;
            padding: 10px 15px;
            cursor: pointer;
        }

            .tab_ul_in li.active {
                background-color: #00a3a1;
                color: #fff;
            }

    .ControlDescription {
        height: 112px !important;
        width: 312px;
    }

    .right_content {
        min-height: calc(100vh - 151px) !important;
    }

    a:hover {
        color: white;
    }


    tr td:first-child {
        text-align: left;
    }

    .domaincls {
        height: calc(100vh - 262px);
        padding: 0px 12px 15px;
        background: #f8f8f8;
        overflow-y: auto;
    }

        .domaincls .table_control {
            margin-top: 12px;
        }

    .nextbtn {
        float: right;
        padding: 8px 16px;
        border: none;
        background: #00a3a1;
        color: #fff;
        text-align: center;
        font-size: 14px;
        -o-transition: 0.3s;
        -moz-transition: 0.3s;
        -webkit-transition: 0.3s;
        transition: 0.3s;
    }

    .backbtn {
        float: left;
        padding: 8px 16px;
        border: none;
        background: #483698;
        color: #fff;
        text-align: center;
        font-size: 14px;
        -o-transition: 0.3s;
        -moz-transition: 0.3s;
        -webkit-transition: 0.3s;
        transition: 0.3s;
    }

    .addbtn {
        margin-top: 32px;
    }

    .orgmap li span.text.active {
        background-color: #915799;
    }
</style>

<section>
    @Html.HiddenFor(m => m.ID)
    @Html.HiddenFor(m => m.MapId)

    <div class="right_section">
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Risk Control Matrix
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-controller="GenerateRCMView" asp-area="ApplicationManagement">Back to Menu</a>
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="row">
                        <div class="col-md-4 col-sm-6 col-xs-12">
                            <label class="required">Organization</label>
                            <div class="select_box m_bottom">
                                @Html.DropDownListFor(m => m.OrgID, Model.DdlParentOrg, "--Select--", new { @class = "form-control m_no", required = "required", disabled = "disabled" })
                            </div>
                        </div>
                        <div class="col-md-8 col-sm-6 col-xs-12">
                            <div class="addbtn">
                                <div class="add_litigation">
                                    <span>+</span>
                                    <input type="button" name="add Control" onclick="fn_openPopup()" value="Add New Control">
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row" id="MainDiv">
                        <div class="col-md-4 col-sm-12 col-xs-12">
                            <div class="domaincls">
                                <ul class="orgmap">
                                    @foreach (var item in Model.DomainList)
                                    {
                                        <li class="first inactive">
                                            <div>
                                                <span class="text Event">@item.DomainName</span>
                                            </div>
                                            <ul>
                                                @foreach (var item2 in Model.SubDomainList.Where(m => m.DomainId == item.Id))
                                                {
                                                    <li>
                                                        <div>
                                                            <span class="text" title="@item2.SubDomainName" onclick="fn_BindRCmControls('@item2.SubDomainName',this)">@item2.SubDomainName</span>
                                                        </div>
                                                    </li>
                                                }
                                            </ul>
                                        </li>
                                    }
                                </ul>
                            </div>
                        </div>
                        <div class="col-md-8 col-sm-12 col-xs-12">
                            <div class="domaincls">
                                <div class="table_control">
                                    <table class="table" id="tblRCm">
                                        <thead>
                                            <tr>
                                                <th>Control Name</th>
                                                <th style="min-width:450px">Control Description</th>
                                                <th>Control ID</th>
                                                <th>Control Type</th>
                                                <th hidden>Governance</th>
                                                <th hidden>Application</th>
                                                <th hidden>Infrastructure</th>
                                                <th hidden>Cloud</th>
                                                <th hidden>Networks</th>
                                                <th hidden>People</th>
                                                <th hidden>Location</th>
                                                <th style="min-width:80px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td colspan="13" class="text-center">No record found...</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>


<div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
        <div class="modal-content">
            <div class="pb-2 mt-4 mb-2 border-bottom box_title pl-2" id="title">
                Add New Control
            </div>
            <div class="modal-body">
                <div class="clsHeght">
                    <div class="tab_ul">
                        <ul class="tab_ul_in">
                            <li id="n1" data-id="domain" class="active">GENERAL</li>
                            <li id="n2" data-id="control">ENABLER MAPPING</li>
                            <li id="n3" data-id="riskthreats">THREATS</li>
                            <li id="n4" data-id="arrequired">ARTEFACTS</li>
                        </ul>
                    </div>
                    <div class="tab_content active " id="domain">
                        <div class="row" style="margin-bottom: 15px;">
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                @Html.Label("NIST Domain")
                                @Html.DropDownListFor(m => m.DomainId, Model.DdlDomain, "Select Domain", new { @class = "form-control m_no", onchange = "GetSubDomain(this)", required = "required" })
                            </div>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                @Html.Label("Control Domain")
                                <select class="form-control m_no" name="SubDomain" id="SubDomain" onchange="fn_getVal(this)" required>
                                    <option value="">Select SubDomain</option>
                                </select>
                            </div>
                        </div>
                        <div class="row" style="margin-bottom: 15px;">
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                @Html.Label("Name of Control")
                                @Html.TextBoxFor(m => m.ControlName, new { @class = "form-control", required = "required", Placeholder = "Enter control name" })
                            </div>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                @Html.Label("Control Type")
                                @Html.DropDownListFor(x => x.ControlTypeId, Model.DdlControlType, "Select Control Type", new { @class = "form-control m_no" })
                            </div>
                        </div>
                        <div class="row" style="margin-bottom: 15px;">
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                @Html.Label("Control ID")
                                @Html.TextBoxFor(m => m.ControlId, new { @class = "form-control", required = "required", ReadOnly = "ReadOnly", PlaceHolder = "Control Id" })
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <label>Control Description</label>
                                <div class="select_box m_bottom">
                                    @Html.TextAreaFor(m => m.ControlDescription, new { @class = "form-control ControlDescription", required = "required", Placeholder = "Enter description" })
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <a href="javascript:void(0)" class="nextbtn" onclick="tabNextBack('control','n2')">Next</a>
                            </div>
                        </div>
                    </div>
                    <div class="tab_content" id="control">
                        <div class="addmultiNameNew">
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Enablers</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ControlCategoryId, Model.DdlControlCategory, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <a href="javascript:void(0)" class="backbtn" onclick="tabNextBack('domain','n1')">Back</a>
                                <a href="javascript:void(0)" class="nextbtn" onclick="tabNextBack('riskthreats','n3')">Next</a>
                            </div>
                        </div>
                    </div>
                    <div class="tab_content" id="riskthreats">
                        <div class="addmultiNameNew">
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Threats</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ThreatId, Model.DdlThreat, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <a href="javascript:void(0)" class="backbtn" onclick="tabNextBack('control','n2')">Back</a>
                                <a href="javascript:void(0)" class="nextbtn" onclick="tabNextBack('arrequired','n4')">Next</a>
                            </div>
                        </div>
                    </div>
                    <div class="tab_content" id="arrequired">
                        <div id="multiRowDiv" class="addmultiName addmultiNameNew">
                            <div class="row addRemoveDiv">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Name</label>
                                    <div class="select_box m_bottom">
                                        <input class="form-control Artefacts" placeholder="Enter name" />
                                    </div>
                                </div>
                                <div class="col-2">
                                    <label class="addbtn" onclick="AddMoreRow()" style="cursor:pointer"></label>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <a href="javascript:void(0)" class="backbtn" onclick="tabNextBack('riskthreats','n3')">Back</a>
                                <div class="submitbtn">
                                    <input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="return fnSetMultiselectValue()">
                                </div>
                                <div class="submitbtn">
                                    <input type="submit" id="btncancel" name="Submit" value="Cancel" onclick="fn_cancel()">
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
